﻿//-----------------------------------------------------------------------------------------------------------
//
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
// KIND, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
// PURPOSE.
//
//------------------------------------------------------------------------------------------------------------
using System;
using System.Linq;
using System.Linq.Expressions;

namespace LinqToHbaseProvider
{
    internal class ExpressionTreeModifier : ExpressionVisitor
    {
        private IQueryable<AccessRecord> queryableRecords;

        internal ExpressionTreeModifier(IQueryable<AccessRecord> places)
        {
            this.queryableRecords = places;
        }

        internal Expression CopyAndModify(Expression expression)
        {
            return this.Visit(expression);
        }

        protected override Expression VisitConstant(ConstantExpression c)
        {
            // Replace the constant QueryableTerraServerData arg with the queryable Place collection.
            if (c.Type == typeof(QueryableHBaseData<AccessRecord>))
                return Expression.Constant(this.queryableRecords);
            else
                return c;
        }
    }
}
