﻿//-----------------------------------------------------------------------------------------------------------
//
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
// KIND, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
// PURPOSE.
//
//------------------------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using org.apache.hadoop.hbase;
using org.apache.hadoop.hbase.client;
using org.apache.hadoop.hbase.util;
using org.apache.hadoop.io;
using org.apache.hadoop.conf;
using org.apache.hadoop.hbase.filter;

namespace LinqToHbaseProvider
{
    static public class HBaseBridge
    {
        static sbyte[] family = null;
        static sbyte[] pageCol = null;
        static sbyte[] ipCol = null;

        static HBaseBridge()
        {
            InitJNBridge.init();

            family = Bytes.toBytes("details");
            pageCol = Bytes.toBytes("page");
            ipCol = Bytes.toBytes("ip");
        }

        public static AccessRecord[] hbaseColumnScan(string column, bool isIP, bool isPage)
        {
            HTable tbl = null;
            Scan scn = null;
            SingleColumnValueFilter svcFilter = null;
            ResultScanner rs = null;
            string pg = null;

            Configuration hbaseConfig = HBaseConfiguration.create();
            hbaseConfig.set("hbase.zookeeper.quorum", "192.168.1.3");
            try
            {
                tbl = new HTable(hbaseConfig, "access_logs");
                scn = new Scan();
                scn.setCaching(500);
                sbyte[] scanColumn = null;
                if (isIP)
                    scanColumn = ipCol;
                else if (isPage)
                    scanColumn = pageCol;

                svcFilter = new SingleColumnValueFilter(family
                    , scanColumn
                    , CompareFilter.CompareOp.EQUAL
                    , Bytes.toBytes(column));

                scn.setFilter(svcFilter);
                rs = tbl.getScanner(scn);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Unable to perform  column scan: " + ex.Message);
            }
            List<AccessRecord> records = new List<AccessRecord>();
            for (Result r = rs.next(); r != null; r = rs.next())
            {
                pg = Bytes.toString(r.getValue(family, pageCol));
                records.Add(new AccessRecord(column, pg));
            }
            rs.close();
            tbl.close();

            return records.ToArray<AccessRecord>();
        }
    }
}
